#!/bin/sh

ksmroot=${ksmroot:-"/mnt/onboard/.adds/kbmenu"}
frontlightprg=$ksmroot/tools/frontlight
dontTamperwithFrontlight=${dontTamperwithFrontlight:-"true"}

if [ "$KSMdebugmode" == "true" ]; then
  debug_logfile=/mnt/onboard/ksmdebug_$(date +%Y%m%d_%H%M%S)_$(basename $0).log
  echo "started: $(date +%Y%m%d_%H%M%S)" > $debug_logfile
  echo "product: $PRODUCT" >> $debug_logfile
fi

# frontligth off
[ "$dontTamperwithFrontlight" == "true" ] && [ "$PRODUCT" != "trilogy" ] && [ "$PRODUCT" != "pixie" ] &&
(
$frontlightprg "0"
[ "$KSMdebugmode" == "true" ] && echo "on start: frontlight level set to 0" >> $debug_logfile
)



# ==== KSM variant of the launcher
# set variables
export ROOT="$vlasovsoftbasedir"
case `/bin/kobo_config.sh * 2>/dev/null` in
 dahlia)  DEVICE=AURAH2O ;;
 dragon)  DEVICE=AURAHD  ;;
 phoenix) DEVICE=AURA    ;;
 kraken)  DEVICE=GLO     ;;
 trilogy) DEVICE=TOUCH   ;;
 pixie)   DEVICE=MINI    ;;
 *)       DEVICE=TOUCH   ;;
esac
export DEVICE
export TMPDIR=/tmp/vlasovsoft
export LANG=en_US.UTF-8
export VLASOVSOFT_KEY=$ROOT/key
export VLASOVSOFT_KBD=$ROOT/kbd.txt
export VLASOVSOFT_FIFO=$TMPDIR/fifo
export VLASOVSOFT_I18N=$ROOT/i18n
export VLASOVSOFT_DICT=$ROOT/dictionary
export QT_PLUGIN_PATH=$ROOT/Qt/plugins
export LD_LIBRARY_PATH=$ROOT/Qt/lib
if [ $DEVICE == AURAH2O ]; then
    export QWS_MOUSE_PROTO=KoboTS_h2o
else
    export QWS_MOUSE_PROTO=KoboTS
fi
export QWS_KEYBOARD=KoboKb
export QWS_DISPLAY=Transformed:KoboFB
export QT_QWS_FONTDIR=$ROOT/fonts
export STYLESHEET=$ROOT/eink.qss
export UPDATE_DELAY_PART=25
export UPDATE_DELAY_FULL=50
cd $ROOT

# kill nickel
#killall nickel
#killall hindenburg

# make the temporary directory for Qt
mkdir -p $TMPDIR

# make fifo
mkfifo $VLASOVSOFT_FIFO

# run launcher
#echo 0 > /sys/class/graphics/fb0/rotate
$ROOT/launcher -qws -stylesheet $STYLESHEET

# remove fifo
rm $VLASOVSOFT_FIFO

#/sbin/reboot

#set frontlight for KSM
[ $PRODUCT != trilogy ] && [ $PRODUCT != pixie ] && (
$frontlightprg "$KSMfrontlightlevel"
[ "$KSMdebugmode" == "true" ] && echo "befor exit: frontlight level set to $KSMfrontlightlevel" >> $debug_logfile
)
